#!/usr/bin/perl -w

use strict;


my $newname = "";

if (scalar @ARGV != 1) {
    print "usage: $0 <type>\n";
    exit -1;
} else {
    $newname = $ARGV[0];
    print "newname is '$newname'\n";
}

my $hostname = `uname -n | sed -e 's/\..*//'`;
my @files = `ls $hostname.*`;

foreach my $file ( @files ) {
    $file =~ s/\n//;
    my $file_type = $file;
    if ( $file_type =~ m/(.*?)\.(.*?)\.(.*)/ ) {
	my $pre = $1;
	my $type = $2;
	my $post = $3;

#	print "file is $file\n";
#	print "pre is '$pre', type is '$type', post is '$post'\n";

	if ( $type eq "cc" ||
	     $type eq "hcucil" ||
	     $type eq "hcunoind" ||
	     $type eq "hcuno" ||
	     $type eq "hcusim" ||
	     $type eq "hcucc" ||
	     $type eq "ginseng" ||
	     $type eq "ginseng_fast" ) {
	    # rename this file
	    my $newfilename = $pre . "." . $type . $newname . "." . $post;
	    print "oldname is '$file'\n";
	    print "newname is '$newfilename'\n";
	    rename $file, $newfilename;
	}
    }
}
