#include "hcu_mappings.h"


hcu_mapping_update_description_t mapping_updates_v112[] = { { "main", "main" } };
hcu_mapping_function_update_description_t mapping_function_updates_v112[] = {
  { "emit_greeting", "emit_greeting", 0 },
  { "vsf_sysutil_wait_reap_one", "vsf_sysutil_wait_reap_one", 0 },
  { "vsf_sysutil_fork", "vsf_sysutil_fork", 0 },
  { "main", "main", 1 },
  { "handle_sigchld___0", "handle_sigchld___0", 0 },
  { "vsf_standalone_main", "vsf_standalone_main", 0 },
  { "vsf_sysutil_accept_timeout", "vsf_sysutil_accept_timeout", 0 },
  { "vsf_log_do_log_vsftpd_format", "vsf_log_do_log_vsftpd_format", 0 }
};

hcu_mapping_algorithmic_equivalence_t mapping_equivalence_v112_vsf_standalone_main[] = {
  { "vsf_standalone_main",
    "vsf_standalone_main",
    2,
    { { 20, 22 },
      { 22, 24 }
    }
  }
};


void hcu_set_update_mode_off();
void hcu_set_update_mode_on();


struct hcu_stack_frame_fields_s {
   long must_come_back_to ;
};


enum EVSFSysUtilError {
    kVSFSysUtilErrUnknown = 1,
    kVSFSysUtilErrADDRINUSE = 2,
    kVSFSysUtilErrNOSYS = 3,
    kVSFSysUtilErrINTR = 4,
    kVSFSysUtilErrINVAL = 5
} ;

/* Why is this incomplete ? */
struct vsf_sysutil_sockaddr;

struct vsf_client_launch {
   unsigned int num_children ;
   unsigned int num_this_ip ;
};
struct vsf_sysutil_ipv4addr {
   unsigned char data[4] ;
};
struct vsf_sysutil_ipv4port {
   unsigned char data[2] ;
};



struct hcu_stack_local_vsf_standalone_main_v111_s {
   struct vsf_sysutil_sockaddr *p_sockaddr___0 ;
   struct vsf_sysutil_ipv4addr listen_ipaddr ;
   int listen_sock ;
   int tmp ;
   int retval ;
   struct vsf_sysutil_ipv4port tmp___0 ;
   int tmp___1 ;
   int tmp___2 ;
   int new_child ;
   int new_client_sock ;
   int tmp___3 ;
   enum EVSFSysUtilError tmp___4 ;
   int tmp___5 ;
   struct hcu_stack_frame_fields_s hcu_stack_frame_fields ;
};

struct hcu_function_formal_vsf_standalone_main_v111_s {

};

struct hcu_stack_local_vsf_standalone_main_v112_s {
   struct vsf_sysutil_sockaddr *p_sockaddr___0 ;
   struct vsf_sysutil_ipv4addr listen_ipaddr ;
   int listen_sock ;
   int tmp ;
   int retval ;
   struct vsf_sysutil_ipv4port tmp___0 ;
   int tmp___1 ;
   int tmp___2 ;
   struct vsf_client_launch child_info ;
   int new_child ;
   struct vsf_sysutil_ipv4addr ip_addr ;
   int new_client_sock ;
   int tmp___3 ;
   int tmp___4 ;
   struct hcu_stack_frame_fields_s hcu_stack_frame_fields ;
};

struct hcu_function_formal_vsf_standalone_main_v112_s {

};



unsigned int hash_ip(unsigned int buckets , void *p_key ) ;
static unsigned int hash_pid(unsigned int buckets , void *p_key ) ;
extern struct hash *s_p_ip_count_hash  ;
static struct hash *s_p_pid_ip_hash  ;


void HCU_stack_transformer__vsf_standalone_main(void *transform_stack_to ,
                                                void *transform_stack_from ,
                                                void *transform_params_to )  __attribute__((__HCU_ATTRIBUTE_NON_UPDATEABLE__)) ;
void HCU_stack_transformer__vsf_standalone_main(void *transform_stack_to ,
                                                void *transform_stack_from ,
                                                void *transform_params_to ) 
{ struct hcu_stack_local_vsf_standalone_main_v112_s *stack_to ;
  struct hcu_stack_local_vsf_standalone_main_v111_s *stack_from ;
  struct hcu_function_formal_vsf_standalone_main_v112_s *params_to ;

  {
  stack_to = (struct hcu_stack_local_vsf_standalone_main_v112_s *)transform_stack_to;
  stack_from = (struct hcu_stack_local_vsf_standalone_main_v111_s *)transform_stack_from;
  params_to = (struct hcu_function_formal_vsf_standalone_main_v112_s *)transform_params_to;
  hcu_copy_stack_frame_fields(& stack_to->hcu_stack_frame_fields,
                              & stack_from->hcu_stack_frame_fields);
  HCU_datatype_transformation__struct__vsf_sysutil_ipv4addr___to_struct__vsf_sysutil_ipv4addr__(& stack_from->listen_ipaddr,
                                                                                                & stack_to->listen_ipaddr);
  HCU_datatype_transformation__struct__vsf_sysutil_ipv4port___to_struct__vsf_sysutil_ipv4port__(& stack_from->tmp___0,
                                                                                                & stack_to->tmp___0);
  stack_to->p_sockaddr___0 = stack_from->p_sockaddr___0;
  stack_to->listen_sock = stack_from->listen_sock;
  stack_to->tmp = stack_from->tmp;
  stack_to->retval = stack_from->retval;
  stack_to->tmp___1 = stack_from->tmp___1;
  stack_to->tmp___2 = stack_from->tmp___2;
  stack_to->new_child = stack_from->new_child;
  stack_to->new_client_sock = stack_from->new_client_sock;
  stack_to->tmp___3 = stack_from->tmp___3;
}

  hcu_set_update_mode_off();
  s_p_ip_count_hash = hash_alloc(256U, sizeof(struct vsf_sysutil_ipv4addr ), sizeof(unsigned int ),
                                 & hash_ip);
  s_p_pid_ip_hash = hash_alloc(256U, sizeof(int ), sizeof(struct vsf_sysutil_ipv4addr ),
                               & hash_pid);
  hcu_set_update_mode_on();
}
