#!/bin/sh

#Should the test files be prepared in a memory filesystem ?
PUT_IN_MEMORY=1
MEMORY_FILESYSTEM_PATH=/dev/shm

rm -rf build/ftparea


if [ $PUT_IN_MEMORY = 1 ]; then
    mkdir -p $MEMORY_FILESYSTEM_PATH/ftparea
    mkdir -p build
    (cd build; ln -s $MEMORY_FILESYSTEM_PATH/ftparea ftparea)
else
    mkdir -p build/ftparea
fi
cd build/ftparea

# Prepare an empty file
touch empty_file
echo Created an empty file


# Prepare a large file
# 300MB file
SIZE=`expr 300 \* 1024`
dd if=/dev/urandom of=large_file  bs=1024 count=$SIZE
echo Created a file of size $SIZE Kbytes
sync

cd ../..
