#include "unsortedNumbers.c"



#include "benchmark_lib.h"

benchmark_times_t bt_before;
benchmark_times_t bt_after;



void printNumbers(float numbers[], int array_size)
{
  int counter = 0;

  printf("The sorted numbers are:\n");
  while (counter < array_size) {
    printf("%f\n", numbers[counter]);
    counter++;
  }
}



#define inner_bubbleSort_loop()     for (j = 1; j <= i; j++) \
    { \
      if (numbers[j-1] > numbers[j]) \
      { \
        temp = numbers[j-1]; \
        numbers[j-1] = numbers[j]; \
        numbers[j] = temp; \
      } \
    } \



void bubbleSort(float numbers[], int array_size)
{
  int i, j, temp;

  printf("Running bubbleSort from the beginning for %d numbers\n", array_size);

  for (i = (array_size - 1); i >= 0; i--)
  {
    // Enlange the function image
    inner_bubbleSort_loop();
    inner_bubbleSort_loop();
    inner_bubbleSort_loop();
    inner_bubbleSort_loop();
    inner_bubbleSort_loop();
  }
}



int main(void)
{
  int array_size  = unsortedNumbersSize;

  /* Initialize the benchmarking library */
  benchmark_lib_init(1);
  benchmark_lib_enable();

  benchmark_lib_pstats_init();
  gettimeofday(&bt_before, NULL);
  bubbleSort(unsortedNumbers, array_size);
  gettimeofday(&bt_after, NULL);

  benchmark_lib_ps_report();
  benchmark_lib_tms_report();

  benchmark_lib_store_times(&bt_before, &bt_after);
  printf("START_BENCHMARK_LIB\n");
  printf("%s", benchmark_lib_tostring() );
  printf("END_BENCHMARK_LIB\n");

  //printNumbers(unsortedNumbers, array_size);

  return 0;
}
