#!/bin/sh


function prepare()
{
    POSTGRES_VERSION_OLD=$1
    POSTGRES_VERSION_NEW=$2

    POSTGRES_VERSION_NUMBER_OLD=`echo -n "$POSTGRES_VERSION_OLD" | sed -e 's/\.//g'`
    POSTGRES_VERSION_NUMBER_NEW=`echo $POSTGRES_VERSION_NEW | sed -e 's/\.//g'`

    cd results

    echo "Producing diff report between versions $POSTGRES_VERSION_NUMBER_OLD and $POSTGRES_VERSION_NUMBER_NEW"
    hcudiff.sh ${POSTGRES_VERSION_OLD}.postgres_comb.c ${POSTGRES_VERSION_NEW}.postgres_comb.c > ${POSTGRES_VERSION_OLD}_to_${POSTGRES_VERSION_NEW}_diff_result.txt 2>&1
    
    cd -
}

prepare 7.4.11 7.4.12
prepare 7.4.12 7.4.13
prepare 7.4.13 7.4.14
prepare 7.4.14 7.4.15
prepare 7.4.15 7.4.16
prepare 7.4.16 7.4.17
prepare 7.4.17 7.4.18
prepare 7.4.18 7.4.19
