#!/bin/sh


function uncompress() 
{
    POSTGRESQL_VERSION=$1
    COMPILER_TYPE=$2

    if [ ! -d build ]; then
        mkdir build
    fi
    cd build
    echo Uncompressing version ${POSTGRESQL_VERSION}.${COMPILER_TYPE}
    tar -jxf ../artifacts/postgresql-${POSTGRESQL_VERSION}.tar.bz2
    mv postgresql-${POSTGRESQL_VERSION} postgresql-${POSTGRESQL_VERSION}.${COMPILER_TYPE}
    cd ..
}


uncompress 7.4.11 hcucc_gcc41
uncompress 7.4.12 hcucc_gcc41
uncompress 7.4.13 hcucc_gcc41
uncompress 7.4.14 hcucc_gcc41
uncompress 7.4.15 hcucc_gcc41
uncompress 7.4.16 cc_gcc41
uncompress 7.4.16 hcucil_gcc41
uncompress 7.4.16 hcumulti_gcc41
uncompress 7.4.16 hcublock_gcc41
uncompress 7.4.16 hcustack_gcc41
uncompress 7.4.16 hcucc_gcc41
uncompress 7.4.17 cc_gcc41
uncompress 7.4.17 hcucil_gcc41
uncompress 7.4.17 hcucc_gcc41
uncompress 7.4.18 hcucc_gcc41
uncompress 7.4.19 hcucc_gcc41
