#include "hcu_mappings.h"


hcu_mapping_update_description_t mapping_updates_v111[] = { { "main", "main" } };
hcu_mapping_function_update_description_t mapping_function_updates_v111[] = {
  { "calculate_chdir_dir", "calculate_chdir_dir", 0 },
  { "common_do_login", "common_do_login", 0 },
  { "emit_greeting", "emit_greeting", 0 },
  { "handle_alarm_timeout", "handle_alarm_timeout", 0 },
  { "handle_rest", "handle_rest", 0 },
  { "handle_rnto", "handle_rnto", 0 },
  { "handle_type", "handle_type", 0 },
  { "handle_upload_common", "handle_upload_common", 0 },
  { "handle_user_command", "handle_user_command", 0 },
  { "process_post_login", "process_post_login", 0 },
  { "str_create_append", "str_create_append", 0 },
  { "vsf_sysutil_a_to_filesize_t", "vsf_sysutil_a_to_filesize_t", 0 },
  { "vsf_sysutil_create_file", "vsf_sysutil_create_file", 0 },
  { "vsf_sysutil_create_overwrite_file", "vsf_sysutil_create_overwrite_file", 0 },
  { "vsf_sysutil_get_current_date", "vsf_sysutil_get_current_date", 0 },
  { "vsf_sysutil_isprint", "vsf_sysutil_isprint", 0 }
};



struct parseconf_bool_setting {
   char const   *p_setting_name ;
   int *p_variable ;
};
struct parseconf_uint_setting {
   char const   *p_setting_name ;
   unsigned int *p_variable ;
};


extern int tunable_port_promiscuous;
extern int tunable_passwd_chroot_enable;
extern int tunable_no_anon_password;

extern unsigned int tunable_file_open_mode;


extern struct parseconf_bool_setting parseconf_bool_array[35] ;
extern struct parseconf_bool_setting parseconf_bool_array_v111[37]  __attribute__((__HCU_ATTRIBUTE_VERSION_HAS_BEEN_SET__))  ;

extern struct parseconf_uint_setting parseconf_uint_array[14] ;
extern struct parseconf_uint_setting parseconf_uint_array_v111[15]  __attribute__((__HCU_ATTRIBUTE_VERSION_HAS_BEEN_SET__))  ;





void HCU_datatype_transformation__struct__parseconf_bool_setting__arraysize35_to_struct__parseconf_bool_setting__arraysize37(struct parseconf_bool_setting (*old)[35] ,
                                                                                                                             struct parseconf_bool_setting (*new)[37] )  __attribute__((__HCU_ATTRIBUTE_VERSION_HAS_BEEN_SET__,
__HCU_ATTRIBUTE_NON_UPDATEABLE__)) ;
void HCU_datatype_transformation__struct__parseconf_bool_setting__arraysize35_to_struct__parseconf_bool_setting__arraysize37(struct parseconf_bool_setting (*old)[35] ,
                                                                                                                             struct parseconf_bool_setting (*new)[37] ) 
{ long array_counter ;

  {
  array_counter = 0;
  while (1) {
    HCU_datatype_transformation__struct__parseconf_bool_setting__arraysize35_to_struct__parseconf_bool_setting__arraysize37__element(& (*old)[array_counter],
                                                                                                                                     & (*new)[array_counter]);
    if (array_counter >= 35 - 1) {
      break;
    }
    array_counter ++;
  }

  ((*new)[33]).p_setting_name = malloc(strlen("port_promiscuous") + 1);
  memcpy(&((*new)[33]).p_setting_name, "port_promiscuous" "\0", strlen("port_promiscuous") + 1);
  ((*new)[33]).p_variable = &tunable_port_promiscuous;

  ((*new)[34]).p_setting_name = malloc(strlen("passwd_chroot_enable") + 1);
  memcpy(&((*new)[34]).p_setting_name, "passwd_chroot_enable" "\0", strlen("passwd_chroot_enable") + 1);
  ((*new)[34]).p_variable = &tunable_passwd_chroot_enable;

  ((*new)[35]).p_setting_name = malloc(strlen("no_anon_password") + 1);
  memcpy(&((*new)[35]).p_setting_name, "no_anon_password" "\0", strlen("no_anon_password") + 1);
  ((*new)[35]).p_variable = &tunable_no_anon_password;

  ((*new)[36]).p_setting_name = 0;
  ((*new)[36]).p_variable = 0;
}
}



void HCU_datatype_transformation__struct__parseconf_uint_setting__arraysize14_to_struct__parseconf_uint_setting__arraysize15(struct parseconf_uint_setting (*old)[14] ,
                                                                                                                             struct parseconf_uint_setting (*new)[15] )  __attribute__((__HCU_ATTRIBUTE_VERSION_HAS_BEEN_SET__,
__HCU_ATTRIBUTE_NON_UPDATEABLE__)) ;
void HCU_datatype_transformation__struct__parseconf_uint_setting__arraysize14_to_struct__parseconf_uint_setting__arraysize15(struct parseconf_uint_setting (*old)[14] ,
                                                                                                                             struct parseconf_uint_setting (*new)[15] ) 
{ long array_counter ;

  {
  array_counter = 0;
  while (1) {
    HCU_datatype_transformation__struct__parseconf_uint_setting__arraysize14_to_struct__parseconf_uint_setting__arraysize15__element(& (*old)[array_counter],
                                                                                                                                     & (*new)[array_counter]);
    if (array_counter >= 14 - 1) {
      break;
    }
    array_counter ++;
  }

  ((*new)[13]).p_setting_name = malloc(strlen("file_open_mode") + 1);
  memcpy(&((*new)[13]).p_setting_name, "file_open_mode" "\0", strlen("file_open_mode") + 1);
  ((*new)[13]).p_variable = &tunable_file_open_mode;

  ((*new)[14]).p_setting_name = 0;
  ((*new)[14]).p_variable = 0;
}
}



int HCU_datatype_transformations_function()  __attribute__((__HCU_ATTRIBUTE_NON_UPDATEABLE__)) ;
int HCU_datatype_transformations_function() 
{ 

  {
  HCU_datatype_transformation__struct__parseconf_bool_setting__arraysize35_to_struct__parseconf_bool_setting__arraysize37(& parseconf_bool_array,
                                                                                                                          & parseconf_bool_array_v111);
  HCU_datatype_transformation__struct__parseconf_uint_setting__arraysize14_to_struct__parseconf_uint_setting__arraysize15(& parseconf_uint_array,
                                                                                                                          & parseconf_uint_array_v111);

  // Initialize these variables
  tunable_file_open_mode  =    438U;
  tunable_no_anon_password  =    0;

  printf("HCU_datatype_transformations_function_v111 executed\n");
  return (0);
}
}
