#include "hcu_mappings.h"


hcu_mapping_update_description_t mapping_updates_v203[] = { { "main", "main" } };
hcu_mapping_function_update_description_t mapping_function_updates_v203[] = {

  { "build_dir_line", "build_dir_line", 0 },
  { "data_transfer_checks_ok", "data_transfer_checks_ok", 0 },
  { "die_unless_privileged", "die_unless_privileged", 0 },
  { "do_file_recv", "do_file_recv", 0 },
  { "emit_greeting", "emit_greeting", 0 },
  { "get_chunk_size", "get_chunk_size", 0 },
  { "handle_alarm_timeout", "handle_alarm_timeout", 0 },
  { "handle_eprt", "handle_eprt", 0 },
  { "handle_mkd", "handle_mkd", 0 },
  { "handle_pasv", "handle_pasv", 0 },
  { "handle_port", "handle_port", 0 },
  { "handle_rnto", "handle_rnto", 0 },
  { "handle_sigalrm", "handle_sigalrm", 0 },
  { "handle_stat", "handle_stat", 0 },
  { "handle_user_command", "handle_user_command", 0 },
  { "main", "main", 1 },
  { "pasv_active", "pasv_active", 0 },
  { "port_active", "port_active", 0 },
  { "prepend_path_to_filename", "prepend_path_to_filename", 0 },
  { "str_lpad", "str_lpad", 0 },
  { "str_netfd_write", "str_netfd_write", 0 },
  { "vsf_ascii_ascii_to_bin", "vsf_ascii_ascii_to_bin", 0 },
  { "vsf_filename_passes_filter", "vsf_filename_passes_filter", 0 },
  { "vsf_ftpdataio_get_port_fd", "vsf_ftpdataio_get_port_fd", 0 },
  { "vsf_sysutil_activate_keepalive", "vsf_sysutil_activate_keepalive", 0 },
  { "vsf_sysutil_activate_linger", "vsf_sysutil_activate_linger", 0 },
  { "vsf_sysutil_activate_oobinline", "vsf_sysutil_activate_oobinline", 0 },
  { "vsf_sysutil_activate_reuseaddr", "vsf_sysutil_activate_reuseaddr", 0 },
  { "vsf_sysutil_set_nodelay", "vsf_sysutil_set_nodelay", 0 },
  { "vsf_sysutil_sockaddr_set_ipv4addr", "vsf_sysutil_sockaddr_set_ipv4addr", 0 }
};


struct parseconf_bool_setting {
   char const   *p_setting_name ;
   int *p_variable ;
};

struct parseconf_str_setting {
   char const   *p_setting_name ;
   char const   **p_variable ;
};



extern char const *tunable_rsa_private_key_file;
extern char const *tunable_dsa_private_key_file;


extern int tunable_force_anon_logins_ssl;
extern int tunable_force_anon_data_ssl;

extern struct parseconf_str_setting parseconf_str_array[29] ;
extern struct parseconf_str_setting parseconf_str_array_v203[31]  __attribute__((__HCU_ATTRIBUTE_VERSION_HAS_BEEN_SET__))  ;


extern struct parseconf_bool_setting parseconf_bool_array[60] ;
extern struct parseconf_bool_setting parseconf_bool_array_v203[62]  __attribute__((__HCU_ATTRIBUTE_VERSION_HAS_BEEN_SET__))  ;



void HCU_datatype_transformation__struct__parseconf_str_setting__arraysize29_to_struct__parseconf_str_setting__arraysize31__element(struct parseconf_str_setting *old ,
                                                                                                                                    struct parseconf_str_setting *new )  __attribute__((__HCU_ATTRIBUTE_VERSION_HAS_BEEN_SET__,
__HCU_ATTRIBUTE_NON_UPDATEABLE__)) ;

void HCU_datatype_transformation__struct__parseconf_bool_setting__arraysize60_to_struct__parseconf_bool_setting__arraysize62__element(struct parseconf_bool_setting *old ,
                                                                                                                                      struct parseconf_bool_setting *new )  __attribute__((__HCU_ATTRIBUTE_VERSION_HAS_BEEN_SET__,
__HCU_ATTRIBUTE_NON_UPDATEABLE__)) ;



void HCU_datatype_transformation__struct__parseconf_str_setting__arraysize29_to_struct__parseconf_str_setting__arraysize31(struct parseconf_str_setting (*old)[29] ,
                                                                                                                           struct parseconf_str_setting (*new)[31] )  __attribute__((__HCU_ATTRIBUTE_VERSION_HAS_BEEN_SET__,
__HCU_ATTRIBUTE_NON_UPDATEABLE__)) ;
void HCU_datatype_transformation__struct__parseconf_str_setting__arraysize29_to_struct__parseconf_str_setting__arraysize31(struct parseconf_str_setting (*old)[29] ,
                                                                                                                           struct parseconf_str_setting (*new)[31] ) 
{ long array_counter ;

  {
  array_counter = 0;
  while (1) {
    HCU_datatype_transformation__struct__parseconf_str_setting__arraysize29_to_struct__parseconf_str_setting__arraysize31__element(& (*old)[array_counter],
                                                                                                                                   & (*new)[array_counter]);
    if (array_counter >= 29 - 1) {
      break;
    }
    array_counter ++;
  }

  ((*new)[28]).p_setting_name = malloc(strlen("rsa_private_key_file") + 1);
  memcpy(&((*new)[28]).p_setting_name, "rsa_private_key_file" "\0", strlen("rsa_private_key_file") + 1);
  ((*new)[28]).p_variable = &tunable_rsa_private_key_file;

  ((*new)[29]).p_setting_name = malloc(strlen("dsa_private_key_file") + 1);
  memcpy(&((*new)[29]).p_setting_name, "dsa_private_key_file" "\0", strlen("dsa_private_key_file") + 1);
  ((*new)[29]).p_variable = &tunable_dsa_private_key_file;

  ((*new)[30]).p_setting_name = 0;
  ((*new)[30]).p_variable = 0;

}
}





void HCU_datatype_transformation__struct__parseconf_bool_setting__arraysize60_to_struct__parseconf_bool_setting__arraysize62(struct parseconf_bool_setting (*old)[60] ,
                                                                                                                             struct parseconf_bool_setting (*new)[62] )  __attribute__((__HCU_ATTRIBUTE_VERSION_HAS_BEEN_SET__,
__HCU_ATTRIBUTE_NON_UPDATEABLE__)) ;
void HCU_datatype_transformation__struct__parseconf_bool_setting__arraysize60_to_struct__parseconf_bool_setting__arraysize62(struct parseconf_bool_setting (*old)[60] ,
                                                                                                                             struct parseconf_bool_setting (*new)[62] ) 
{ long array_counter ;

  {
  array_counter = 0;
  while (1) {
    HCU_datatype_transformation__struct__parseconf_bool_setting__arraysize60_to_struct__parseconf_bool_setting__arraysize62__element(& (*old)[array_counter],
                                                                                                                                     & (*new)[array_counter]);
    if (array_counter >= 60 - 1) {
      break;
    }
    array_counter ++;
  }

  ((*new)[59]).p_setting_name = malloc(strlen("force_anon_logins_ssl") + 1);
  memcpy(&((*new)[59]).p_setting_name, "force_anon_logins_ssl" "\0", strlen("force_anon_logins_ssl") + 1);
  ((*new)[59]).p_variable = &tunable_force_anon_logins_ssl;

  ((*new)[60]).p_setting_name = malloc(strlen("force_anon_data_ssl") + 1);
  memcpy(&((*new)[60]).p_setting_name, "force_anon_data_ssl" "\0", strlen("force_anon_data_ssl") + 1);
  ((*new)[60]).p_variable = &tunable_force_anon_data_ssl;

  ((*new)[61]).p_setting_name = 0;
  ((*new)[61]).p_variable = 0;

}
}



int HCU_datatype_transformations_function()  __attribute__((__HCU_ATTRIBUTE_NON_UPDATEABLE__)) ;
int HCU_datatype_transformations_function() 
{ 

  {
  HCU_datatype_transformation__struct__parseconf_str_setting__arraysize29_to_struct__parseconf_str_setting__arraysize31(& parseconf_str_array,
                                                                                                                        & parseconf_str_array_v203);
  HCU_datatype_transformation__struct__parseconf_bool_setting__arraysize60_to_struct__parseconf_bool_setting__arraysize62(& parseconf_bool_array,
                                                                                                                          & parseconf_bool_array_v203);

  // Initialize these new variables
  tunable_force_anon_logins_ssl = 0;
  tunable_force_anon_data_ssl = 0;
  tunable_rsa_private_key_file = 0;
  tunable_dsa_private_key_file = 0;

  printf("HCU_datatype_transformations_function_v203 executed\n");
  return (0);
}
}


