#include "hcu_mappings.h"


hcu_mapping_update_description_t mapping_updates_v207[] = { { "main", "main" } };
hcu_mapping_function_update_description_t mapping_function_updates_v207[] = {
  { "do_file_recv", "do_file_recv", 0 },
  { "emit_greeting", "emit_greeting", 0 },
  { "ftp_read_data", "ftp_read_data", 0 },
  { "handle_dir_common", "handle_dir_common", 0 },
  { "handle_pasv", "handle_pasv", 0 },
  { "handle_retr", "handle_retr", 0 },
  { "handle_stat", "handle_stat", 0 },
  { "handle_upload_common", "handle_upload_common", 0 },
  { "main", "main", 1 },
  { "ssl_data_close", "ssl_data_close", 0 },
  { "ssl_read", "ssl_read", 0 },
  { "vsf_ftpdataio_dispose_transfer_fd", "vsf_ftpdataio_dispose_transfer_fd", 0 },
  { "vsf_privop_get_ftp_port_sock", "vsf_privop_get_ftp_port_sock", 0 },
  { "vsf_standalone_main", "vsf_standalone_main", 0 },
  { "vsf_sysutil_getcwd", "vsf_sysutil_getcwd", 0 },
  { "vsf_sysutil_listen", "vsf_sysutil_listen", 0 },
  { "vsf_sysutil_readlink", "vsf_sysutil_readlink", 0 }
};



hcu_mapping_algorithmic_equivalence_t mapping_equivalence_v207_vsf_standalone_main[] = {
  { "vsf_standalone_main",
    "vsf_standalone_main",
    1,
    { { 44, 46 }
    }
  }
};


void hcu_set_update_mode_off();
void hcu_set_update_mode_on();


struct hcu_stack_frame_fields_s {
   long must_come_back_to ;
};

typedef struct hcu_stack_frame_fields_s hcu_stack_frame_fields_t;


struct parseconf_bool_setting {
   char const   *p_setting_name ;
   int *p_variable ;
};


extern struct parseconf_bool_setting parseconf_bool_array[68];

struct parseconf_bool_setting parseconf_bool_array_v207[72];


int tunable_strict_ssl_read_eof ;
int tunable_strict_ssl_write_shutdown ;
int tunable_ssl_request_cert ;
int tunable_delete_failed_uploads ;



void HCU_datatype_transformation__struct__parseconf_bool_setting__arraysize68_to_struct__parseconf_bool_setting__arraysize72(struct parseconf_bool_setting (*old)[68] ,
                                                                                                                             struct parseconf_bool_setting (*new)[72] )  __attribute__((__HCU_ATTRIBUTE_VERSION_HAS_BEEN_SET__,
__HCU_ATTRIBUTE_NON_UPDATEABLE__)) ;
void HCU_datatype_transformation__struct__parseconf_bool_setting__arraysize68_to_struct__parseconf_bool_setting__arraysize72(struct parseconf_bool_setting (*old)[68] ,
                                                                                                                             struct parseconf_bool_setting (*new)[72] ) 
{ long array_counter ;

  {
  array_counter = 0;
  while (1) {
    HCU_datatype_transformation__struct__parseconf_bool_setting__arraysize68_to_struct__parseconf_bool_setting__arraysize72__element(& (*old)[array_counter],
                                                                                                                                     & (*new)[array_counter]);
    if (array_counter >= 68 - 1) {
      break;
    }
    array_counter ++;
  }

  // Must extend the array
  ((*new)[67]).p_setting_name = malloc(strlen("strict_ssl_read_eof") + 1);
  memcpy(&((*new)[67]).p_setting_name, "strict_ssl_read_eof" "\0", strlen("strict_ssl_read_eof") + 1);
  ((*new)[67]).p_variable = &tunable_strict_ssl_read_eof;

  ((*new)[68]).p_setting_name = malloc(strlen("strict_ssl_write_shutdown") + 1);
  memcpy(&((*new)[68]).p_setting_name, "strict_ssl_write_shutdown" "\0", strlen("strict_ssl_write_shutdown") + 1);
  ((*new)[68]).p_variable = &tunable_strict_ssl_write_shutdown;

  ((*new)[69]).p_setting_name = malloc(strlen("ssl_request_cert") + 1);
  memcpy(&((*new)[69]).p_setting_name, "ssl_request_cert" "\0", strlen("ssl_request_cert") + 1);
  ((*new)[69]).p_variable = &tunable_ssl_request_cert;

  ((*new)[70]).p_setting_name = malloc(strlen("delete_failed_uploads") + 1);
  memcpy(&((*new)[70]).p_setting_name, "delete_failed_uploads" "\0", strlen("delete_failed_uploads") + 1);
  ((*new)[70]).p_variable = &tunable_delete_failed_uploads;

  ((*new)[71]).p_setting_name = 0;
  ((*new)[71]).p_variable = 0;

}
}



int HCU_datatype_transformations_function()  __attribute__((__HCU_ATTRIBUTE_NON_UPDATEABLE__)) ;
int HCU_datatype_transformations_function() 
{ 

  {
  HCU_datatype_transformation__struct__parseconf_bool_setting__arraysize68_to_struct__parseconf_bool_setting__arraysize72(& parseconf_bool_array,
                                                                                                                          & parseconf_bool_array_v207);

  tunable_strict_ssl_read_eof = 0 ;
  tunable_strict_ssl_write_shutdown = 0;
  tunable_ssl_request_cert = 1;
  tunable_delete_failed_uploads = 0;

  printf("HCU_datatype_transformations_function_v207 executed\n");
  return (0);
}
}
