#!/bin/sh



function uncompress_ftp_benchmark()
{
    mkdir build
    cd build
    echo Uncompressing dkftpbench 0.45
    tar -zxf ../artifacts/dkftpbench-0.45.tar.gz
    cd ..
}


function uncompress() 
{
    VSFTPD_VERSION=$1
    COMPILER_TYPE=$2

    if [ ! -e build ]; then
        mkdir build
    fi
    cd build
    echo Uncompressing version ${VSFTPD_VERSION}.${COMPILER_TYPE}
    tar -zxf ../artifacts/vsftpd-${VSFTPD_VERSION}.tar.gz
    mv vsftpd-${VSFTPD_VERSION} vsftpd-${VSFTPD_VERSION}.${COMPILER_TYPE}
    cd ..
}

uncompress_ftp_benchmark
uncompress 1.1.0 hcucc_gcc41
uncompress 1.1.1 hcucc_gcc41
uncompress 1.1.2 hcucc_gcc41
uncompress 1.1.3 hcucc_gcc41
uncompress 1.2.0 hcucc_gcc41
uncompress 1.2.1 hcucc_gcc41
uncompress 1.2.2 hcucc_gcc41
uncompress 2.0.0 hcucc_gcc41
uncompress 2.0.1 hcucc_gcc41
uncompress 2.0.2 hcucc_gcc41
uncompress 2.0.3 hcucc_gcc41
uncompress 2.0.4 hcucc_gcc41
uncompress 2.0.5 cc_gcc41
uncompress 2.0.5 hcumulti_gcc41
uncompress 2.0.5 hcublock_gcc41
uncompress 2.0.5 hcustack_gcc41
uncompress 2.0.5 hcucc_gcc41
uncompress 2.0.6 cc_gcc41
uncompress 2.0.6 hcucc_gcc41
